SNC21030
SN0#XO.WAV
SN1#XO.WAV
SIL#XO.WAV
TICK_TOCK_12K.WAV
GAME_SHOW_BUZZER_12K.WAV
RPG_AND_EXPLOSION_12K.WAV
PROGRAM
deboc	equ	#0101b
	IR_MODE	EQU	#0000B
MRX	EQU	#1111B
MRXB	EQU	#0000B
MRX32	EQU	#1111B
MRX48	EQU	#1111B
MRX64	EQU	#1111B
KeyP1	EQU	#0001B
KeyP2	EQU	#0000B
KeyP3	EQU	#0000B
Rand0Max	EQU	#0000B
Rand1Max	EQU	#0000B
Rand2Max	EQU	#0000B
;#####################################################
; For SNC10000 Series (SNC12007 to SNC12340)
; Instruction Cycle : 4 us
; I/O      : P1, P2,P3
; Channel  : 1  ( DAC & PWM )
; Core program : SNC10KEZ  ( 1-channel , 12 ports)
; ----------------------------------------------------
; Scan Key          : P2 --> P1  ( Max 16 keys)
; Direct Key        : P1,P2 and P3 ( Max 12 keys)
; Flash with volume : P3 with CH1
; Output Control    : P1, P2,P3
;#####################################################

;/////////////////////////////////////////
tr1_4           equ     m0
tr5_8           equ     m1
tr9_12          equ     m2
tr13_16         equ     m3
p2state         equ     m4
p3state         equ     m5
4mto8m          equ     m6
; Bit 0 --> 1: Head being played, need play tail before power down
; Bit 1 --> Debonce Counter
; Bit 2 --> =1 ... 8ms
; Bit 3 --> Debonce


p3_fva          equ     m7    ; Flash with CH1
VolValue_Page0	equ	m8    ; Add by Allan for record Volume
v_state         equ     m9    ; Speech state
;ret_flag	equ	m9    ; bit0 ....... CH 1
;                              ; bit1 ....... FG return flag ==> 1: FG play return / 0 : FG Delay return
;                              ; bit2 ....... BACK CH 1
;                              ; bit3 ....... BG return flag ==> 1: BG play return / 0 : BG Delay return
EZIO_FG			equ	m9	; bit0 ....... CH 1
                              		; bit1 ....... EZIO FG or BG choose ; 1:FG / 0:BG
                              		; bit2 ....... BACK CH 1
                              		; bit3 ....... X
ret_flag		equ	m10		; bit0 & 1 : FG return
						; bit2 & 3 : BG return
						; 00 : all not ret
						; 01 : EZIO ret
						; 10 : delay ret
						; 11 : play ret
;deboc_count	equ	m10
;;bit 0   ..... for debounce counter 4-->8 ms
;;bit1~3  ..... debounce counter 8~56ms

;for MIX key trigger.
Mtr2		equ	m11
Mtr3		equ	m12

temp1           equ     m13	;ScanKey KeyID used.
KeyID		equ	m13
;Temp RAM.
temp2           equ     m14
temp2_0		equ	m14
temp3           equ     m15
;trigger change condition
;---------------page1--------------
delay8m         equ     m0
delay01         equ     m1
delay1s         equ     m2
BGround1        equ     m3
BGround2        equ     m4
P2S_STATE       EQU     M5
P3S_STATE       EQU     M6
s_delay1        equ     m7
s_delay2        equ     m8
s_delay3        equ     m9
TrigState1      equ     m10
TrigState2      equ     m11
Delay_Flag	equ	m12
; Bit 0 --> Foreground Delay 8ms flag
; Bit 1 --> Background Delay 8ms flag
; Bit 2 --> Output     Delay 8ms flag
temp4           equ     m13
Time_Counter	equ	m13
IO_tmp1		equ	m13
temp5           equ     m14
RECEIVE_COUNT_1   EQU     M14
TRANS_COUNT_1     EQU     M14
IO_tmp2		equ	m14
; Bit 0 --> Inline Assembly Return 1 used flag
; Bit 1 --> Inline Assembly Return 2 used flag
p1state         equ     m15
;******* page2 ***********
p2_go1          equ     m0
p2_go2          equ     m1
p3_go1          equ     m2
p3_go2          equ     m3
loop            equ     m4
outloop         equ     m5
p3_fv1          equ     m7
Rand0           equ     m8
Rand1           equ     m9
;Rand2           equ     m10
deboc_count	equ	m10							;page0->page2 edit by CYH 09/04/29
;bit 0   ..... for debounce counter 4-->8 ms
;bit1~3  ..... debounce counter 8~56ms   
enter_b         equ     m11
p_delay1        equ     m12
p_delay2        equ     m13
p_delay3        equ     m14
m_stp           equ     #0011b
m_pause         equ     #0001b
p1_go1          equ     m6
p1_go2          equ     m15

;---------------page4--------------
;=================================20080418 new===================================
EventFlag	equ	m0	; used for event mark enable or disable flag
mask_fra1	equ	m1	; used for fv debounce
fra1_flag	equ	m2	; used for fv debounce
EZ_MarkH	equ	m3	; used for bit5&4 of 6 bit event mark in EZIO
;m4	used for fv debounce
;================================================================================
Temp6		equ	m5
Temp7		equ	m6

Next_flag	equ	m7	
;bit0 e
;bit1 I
EZ_Mark		equ	m8
EZIO_timerL	equ	m9
EZIO_timerH	equ	m10
EZIO_flag	equ	m11
;;;; IR Tx
TRANS_H         EQU     M12
TRANS_L         EQU     M13
;;;; IR Rx
RECEIVE_H       EQU     M12
RECEIVE_L       EQU     M13

;;;; PAGE4   M14.0 ;;;;;;;;
IRout_ON_OFF_3_0   EQU      M14
;;;; PAGE4   M14.1 ;;;;;;;;
TRIGGER_FLAG_3_1   EQU     M14   ;

;;;; PAGE4   M14.2 ;;;;;;;;;
IRin_ON_OFF_3_2     EQU      M14  ;
; BIT2=0 ........ IR OFF
; BIT2=1 ........ IR ON

;;;; PAGE2   M12.3 ;;;;;;;;
IR_TX_P33_ON_OFF_3_3  EQU    M14 ;
; BIT3=0 ........ P3.3 38.5K Hz OFF
; BIT3=1 ........ P3.3 38.5K Hz ON


PWMIOEN1	equ	m15
/*
ifdef @_key_type_@				;add at 5-26'04 for mix key
;Mtr2		equ	m10			;disable 2005/05/30 , page have define
;Mtr3		equ	m11			;In Mix key mode,memory direct key status

endif
*/
;**************** MACRO **************************
;--------------------------------------------
;	CAJNE	Macro
;--------------------------------------------
CAJNE	Macro	Memory,Address
	CAJE	Memory,@F
	JMP	Address
@@:
ENDM

;--------------------------------------------
;	CallTo	Macro	Label
;--------------------------------------------
JumpTo	Macro	label
	Jmp	label
@@&label&_Bk:
ENDM
includestd		macro21K.h
includestd		ProductionTestMode_12.asm

;##########################################################
; ###################  Program Start  ###################
;##########################################################
start:                                  ;power on initial routine
	JumpTo	Initial_Chip
	JumpTo	Update_Key
	jmp     @@_init
Main_Loop:
;;;;;;;; For IR transmit function ;;;;;;;;;;;;;;;;;;;;;
ifdef   IR_TRANSMIT
        JMP     @IR_TRANSMIT
@IR_TRANSMIT_OK:
endif

ifdef   IR_Receive
;;;;;;;; For IR receive function ;;;;;;;;;;;;;;;;;;;;;
        JMP     @IR_RECEIVE
@IR_RECEIVE_OK:
endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	JumpTo	ScanKey				; Scankey Function.
	
	JumpTo	Update_Output			; I/O output Function.
	JumpTo	Check_Random			; Random Function.
	;JumpTo	Check_Speech			; Speech Play Function.
	JumpTo	Check_Timer			; 4ms Timer.
	JumpTo	Check_Delay
	JumpTo	Check_EZIO
	JumpTo	Check_Event			; Event Mark Function.
	page1
	Jmp	@@CHKBGROUND			; Check BackGround.
@@CHKBGROUND_BACK:
	JumpTo	Check_PowerDown			; Power Down Routine
@@Scankey1:
@@Toggle_2_Back:
	JumpTo	Check_EnterB			; Check Enter B function.
	Jmp	Main_Loop
/*
;##########################################################
;########## FG ret_flag ###################################
;#############################################################
@@FG_reset:
	Page1
	Mov	delay8m	#0000b	                ;// reset FG delay
	Page0
	Mov 	a	#1100b
	And	a	ret_flag
	Mov	ret_flag	a		;//reset FG ret_flag
	Ret1
*/
/*	
;##########################################################
;########## BG  ret_flag ###################################
;#############################################################	
@@BG_reset:
	Page2
	Mov	P_delay1	#0000b		;// reset BG delay
	Page0
	Mov	a	#0011b
	And	a	ret_flag
	Mov	ret_flag	a		;//reset BG ret_flag
	Ret2
*/
;##########################################################
; ###################  Wake Up Routine ###################
;##########################################################
trigger:
        rstc
        rstcf
@@ini_lp:
        cjc     @@ready_scan
        jmp     @@ini_lp
@@ready_scan:
        rstcf
;;;; Scankey P2-->P1
        page0
        mov     a       mrx
        and     a       p2state
ifdef	@_key_type_@
	mov     p2state a
	mov	a	keyp2 
	and	a	p2state
endif	               
        mov     p2state a
        mov     p2      a
	
;;;;;; For IR  receive function  ;;;;;;
;;;;;; WAKEUP STATE
ifdef   IR_Receive	;2005/10/4 09:55W by yc
        PAGE4
        MOV     A,#0010B
        OR      A,TRIGGER_FLAG_3_1
        MOV     TRIGGER_FLAG_3_1,A ;; TRIGER FLAG for IR
endif			;2005/10/4 09:56W by yc	
@@scankey:
	; Force All delay Routine Stop.
        page1
        mov     delay8m #0000b		
        mov     s_delay1 #0
        page2
        mov     p_delay1        #0000b
	Jmp	Main_Loop
	
;##########################################
;   -------- Initial Chip --------
;========================================
; This function is used to Initial those
; Memory used.
;----------------------------------------
Initial_Chip:
        page0    
        stop
	rcode
        mov     a       #1111b
        mov     p2s     a
        mov     p3s     a

        mov     a       #0000b
        mov     p3      a
        mov     p3state a
        mov     p2      a
        mov     p2state a

        mov     tr1_4   #0000b          ;m0:tr1-4 status, m1:tr5-8 status
        mov     tr5_8   #0000b          ;m2:tr9-12 status, m3:tr13-16 status
        mov     tr9_12  #0000b            
        mov     tr13_16 #0000b          
        mov     m6      #0000b          ;m6.2:8ms,bit3:debounce,bit0:head
        mov     p3_fva  #0000b
        mov     v_state #0000b
        mov     m14     #0000b          ;m14:
        mov     m15     #0000b          ;m15:scan of p1 bit
        mov	a,#0111b
        mov	VolValue_Page0,a	; add by Allan, set Master Vol is Max        
        page1
        mov     delay8m #0000b          ;m0:delay
        mov     s_delay1 #0000b
        MOV     Delay_Flag   #0000B
        mov     bground1        #0000b
        mov     bground2        #0000b
        page2
        mov     p2_go1  #0000b                  ;x=1
        mov     p2_go2  #1111b                  ;x=0
        mov     p3_go1  #0000b                  ;x=1
        mov     p3_go2  #1111b                  ;x=0
	mov     p1_go1  #0000b                  ;x=1
        mov     p1_go2  #1111b                  ;x=0
        
        mov     p3_fv1  #0000b
        mov     p_delay1 #0000b
        mov     Rand0   #0
        mov     Rand1   #0
;        mov     Rand2   #0
		page0
        mov     ret_flag   #0
        page2    
        mov     enter_b #0000b

;;;; For Drive & Sink function ;;;;;;;;;;;
        Page1
        MOV     A       #1111B
        MOV     P2S_STATE  A
        MOV     P3S_STATE  A
        page0
        MOV     A       IR_MODE
        or	a	VolValue_Page0
        MOV     MODE     A
        mov	VolValue_Page0 a
        MOV     A       IR_MODE
        CAJE    #0000B   @F
        MOV     A        #1000B
@@:
        PAGE4
        OR      A,IR_TX_P33_ON_OFF_3_3
        MOV     IR_TX_P33_ON_OFF_3_3,A
        mov	EventFlag	#0001b		; 20080417 clayton , default of event is enable        
        
ifdef	@_key_type_@ 				;add at 05-26'04 for mix key
	page0       
	mov	Mtr2	#0000b
	mov	Mtr3	#0000b
endif
	Jmp	@@Initial_Chip_Bk
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;##########################################
;   -------- Update --------
;========================================
; This function is used Update Key 
; Information.
;----------------------------------------
update_Key:
        page0
        mov     a       mrx
        caje    #1111b  @@update_key
        mov     a       #0001b
        mov     p2      a
        mov     a       mrx
        mov     p2s     a
        mov     a       #1111b
        mov     p2s     a
        mov     a       p1
        mov     tr1_4   a
        mov     a       #0010b
        mov     p2      a
        mov     a       mrx
        mov     p2s     a
        mov     a       #1111b
        mov     p2s     a
        mov     a       p1
        mov     tr5_8   a
        mov     a       mrx
        caje    #1100b  @@update_over
        mov     a       #0100b
        mov     p2      a
        mov     a       mrx
        mov     p2s     a
        mov     a       #1111b
        mov     p2s     a
        mov     a       p1
        mov     tr9_12  a
        mov     a       mrx
        caje    #1000b  @@update_over
        mov     a       #1000b
        mov     p2      a
        mov     a       mrx
        mov     p2s     a
        mov     a       #1111b
        mov     p2s     a
        mov     a       p1
        mov     tr13_16 a
@@update_over:
        mov     a       #0000b
        mov     p2      a
ifdef 	@_key_type_@				;add at 05-26'04 for mix key
        mov     a       p2
        mov     temp1     a
        mov     a       keyp2
        and     a       temp1
	mov     Mtr2   a
	mov     a       p3
        mov     temp1     a
        mov     a       keyp3
        and     a       temp1
	mov     Mtr3  a
endif 
;******************************************************
        Jmp	@@Update_Key_Bk
;******************************************************
@@update_key:
        mov     a       p1
        mov     KeyID   a
        mov     a       keyp1
        and     a       KeyID
        mov     tr1_4   a

        mov     a       p2
        mov     KeyID   a
        mov     a       keyp2
        and     a       KeyID
        mov     tr5_8   a

        mov     a       p3
        mov     KeyID   a
;;;; If IR occur ....disable p33 , p32
        
        MOV     TEMP2_0,#1111B
ifdef   IR_Transmit
ifdef   IR_Receive
;;;   IR_Bidirection
        
        MOV     TEMP2_0,#0011B
else
;;;; IR_TRANSMIT
        
        MOV     TEMP2_0,#0111B
endif
elseifdef       IR_Receive
;;;;;   IR_RECEIVE
        
        MOV     TEMP2_0,#0111B
endif
        
        mov     a       keyp3
        and     a       KeyID
        mov     tr9_12  a
        jmp     @@Update_Key_Bk

;##########################################
;   -------- Check Enter B --------
;========================================
;
;----------------------------------------
Check_EnterB:
        page2
        mov     a       #0001b
        and     a       enter_b
        caje    #0000b  @@Check_EnterB_Bk
        mov     a       #1110b
        and     a       enter_b
        mov     enter_b a
        page3
        ret1

;##########################################
;   -------- Check Speech Play --------
;========================================
; check speech playing
; It seems like Flash with volume only.
; Need further check.
;----------------------------------------
Check_Speech:
	page4
	mov	a	Next_flag
	caje	#0	@f
	mov	a	nxtply
	caje	#14	@f
	mov	a	Next_flag
	caje	#1	@@fv1_ok_ret11
	caje	#2	@@fv1_ok_ret2

@@:	
        page0
        mov     a       #0001b
        and     a       v_state

        caje    #0000b  @@no_v1_1
        jmp     @@with_v1
@@no_v1_1:
        mov     a       #1111b
        xor     a       p3_fva
        and     a       p3state
        mov     p3state a
        mov     p3      a
        jmp     @@no_v1
@@with_v1:
;=============== new fv ====================
	mov	a	#1111b
	page4
	xor	a	fra1_flag
	page0
	mov	m15	#0100b
	and	a	m15
        caje    #0100b  @@v1_fsh		
        jmp     @@no_v1_fsh
;===================================
@@no_v1_fsh:
        mov     a       #1111b
        xor     a       p3_fva
        and     a       p3state
        mov     p3state a
        mov     p3      a
        jmp     @@fv1_ok
@@v1_fsh:
        page0
        mov     a       p3_fva
        or      a       p3state
        mov     p3state a
        mov     p3      a
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@fv1_ok:
;ifdef  @@_EZ_IO_@@
;        page4
;        mov	a	#0100b
;        and	a	EZIO_flag
;        page0
;        caje	#0000b	@wave_end_check	;EZIO_flag.2=0 : EZIO ending by wave / EZIO_flag.2=1 : EZIO ending by eio end mark
; @eio_end_check:
;        page4
;        mov	a	#0001b
;        and	a	EZIO_flag
;        page0
;        caje	#0001b	@@no_v1		;EZIO_flag.0=0 : eio end mark detected or force to stop / EZIO_flag.0=1 : EZIO keep going
;        jmp	@END_EZIO    
;          	
;@extend_fake_check:
;	mov	a	fra2
;	caje	#0100b	@@no_v1
;	jmp	@wave_end_check2
;	
; @wave_end_check:
;	page0
;        mov	a	temp2
;        caje	#0011b	@extend_fake_check	
;endif
; @wave_end_check2:
 	page0
        CJP    @@no_v1                     ;voice is playing
; @END_EZIO:
;        Play   sil#xo.wav
        mov     a       #1110b
        and     a       v_state
        mov     v_state a

        PAGE0
        mov     a       #0100b
        and     a       v_state
        caje    #0000b  @@fv1_ok_ret1

        mov     a       #1011b
        and     a       v_state
        mov     v_state a


        PAGE2
        mov     a       #0100b
        and     a       enter_b
        caje    #0000b  @@fv1_ok_ret2
        mov     a       #1011b
        and     a       enter_b
        mov     enter_b a
        jmp     @@scankey1
@@fv1_ok_ret2:
	page0
;	mov	a	#1000b
 	mov	a	#1100b
	and	a	ret_flag
	caje	#1100b	@@fv1_ok_ret2_ok
	jmp	@@no_v1
@@fv1_ok_ret2_ok:
	page0
	mov	a	#0011b
	and	a	ret_flag
	mov	ret_flag	a
;	caje	#0	@@no_v1
;;	 @@chk_p_delay1_ret2	@@no_v1		;add in 04/10/2003 for ret2 problem
        page3					;mark in 04/10/2003
        ret2					;mark in 04/10/2003

@@fv1_ok_ret1:
        PAGE2
        mov     a       #0100b
        and     a       enter_b
        caje    #0000b  @@fv1_ok_ret11
        mov     a       #1011b
        and     a       enter_b
        mov     enter_b a
        jmp     @@scankey1
@@fv1_ok_ret11:
	page0
;	mov	a	#0010b
	mov	a	#0011b
	and	a	ret_flag
	caje	#0011b	@@fv1_ok_ret11_ok
	jmp	@@no_v1
@@fv1_ok_ret11_ok:
	page0
	mov	a	#1100b
	and	a	ret_flag
	mov	ret_flag	a
;	caje	#0	@@no_v1
;;	@@chk_delay8m_ret1	@@no_v1		;add in 04/10/2003 for ret1 problem
        page3					;mark in 04/10/2003
        ret1					;mark in 04/10/2003
@@no_v1:
@@no_s_play:
        jmp     @@Check_Speech_Bk

;##########################################
;   -------- Check Delay --------
;========================================
; When EZ paste delay command into program,
; Please remember to clear corresponding
; Delay Flag only. 
; (Do not clear other delay flag)
;----------------------------------------
Check_Delay:
	page1
	;Check if 8ms Delay occur.
	mov	a	#0111B
	and	a	Delay_Flag
	Caje	#0	@@Check_Delay_Bk

;===============================
;====== Foreground Delay =======
;===============================
@@Chk_FG_Delay:
	;Check if foreground Delay enable
        page1
         mov	a	#0001B			;2005/6/20 04:35U
	and	a	Delay_Flag		;2005/6/20 04:35U
	Caje	#0	@@Chk_BG_Delay		;2005/6/20 04:35U
	;Clear foreground 8ms Flag.
	
	mov	a	#1110b
	and	a	Delay_Flag
	mov	Delay_Flag	a

        mov	a	delay8m
	Caje	#0	@@delay_end
@@delay:
        mov     a       delay8m
        inca
        mov     delay8m a
        caje    #0000b  @@01_sec
        jmp	@@delay_end
@@01_sec:
        mov     delay8m #0100b
        mov     a       delay01
        inca
        mov     delay01 a
        caje    #0000b  @@1sec
        jmp	@@delay_end
@@1sec:
        mov     delay01 #0110b
        mov     a       delay1s
        inca
        mov     delay1s a
        caje    #0000b  @@delay_ok
        jmp	@@delay_end
        ; Delay counted, turn off delay and
        ; issue a return1 back to user foreground path.
@@delay_ok:
        mov     delay8m #0000b

	page0
;	mov	a	#0010b
	mov	a	#0011b		
	and	a	ret_flag
	caje	#0010b	@@delay_ok_ret1
    jmp		@@delay_end
@@delay_ok_ret1:
	page0
	mov	a	#1100b
	and	a	ret_flag
	mov	ret_flag	a	
;	caje	#0010b	@@delay_end

        page3
        ret1
@@delay_end:
;===============================
;====== Background Delay =======
;===============================
@@Chk_BG_Delay:	
	;Check if background Delay enable
        page1
        mov	a	#0010B			;2005/6/20 04:35U
	and	a	Delay_Flag		;2005/6/20 04:35U
	Caje	#0	@@Chk_O_Delay		;2005/6/20 04:35U
	mov	a	#1101b
	and	a	Delay_Flag
	mov	Delay_Flag	a
	
        mov	a	s_delay1
	Caje	#0	@@delay1_end
@@delay1:
        mov     a       s_delay1
        inca
        mov     s_delay1 a
        caje    #0000b  @@s01_sec
	jmp	@@delay1_end
@@s01_sec:
        mov     s_delay1 #0100b
        mov     a       s_delay2
        inca
        mov     s_delay2 a
        caje    #0000b  @@s1sec
	jmp	@@delay1_end
@@s1sec:
        mov     s_delay2 #0110b
        page1
        mov     a       s_delay3
        inca
        mov     s_delay3 a
        caje    #0000b  @@s_delay_ok
	jmp	@@delay1_end
@@s_delay_ok:
 	; Delay counted, turn off delay
 	; and issue ret2 for return to
 	; user background path.
        mov     s_delay1 #0000b
        page3
        ret3
@@delay1_end:
;===============================
;======   Output Delay   =======
;===============================
@@Chk_O_Delay:	
	page1
	mov	a	#0100B			;2005/6/20 04:34U
	and	a	Delay_Flag		;2005/6/20 04:34U
	Caje	#0	@@delayp_end		;2005/6/20 04:35U
	mov	a	#1011b
	and	a	Delay_Flag
	mov	Delay_Flag	a
	
	;Check if Output Delay enable
        page2
	mov	a	p_delay1
	Caje	#0	@@delayp_end
@@delayp:
        mov     a       p_delay1
        inca
        mov     p_delay1 a
        caje    #0000b  @@p01_sec
	jmp	@@delayp_end
@@p01_sec:
        mov     p_delay1 #0100b
        mov     a       p_delay2
        inca
        mov     p_delay2 a
        caje    #0000b  @@p1sec
	jmp	@@delayp_end
@@p1sec:
        mov     p_delay2 #0110b
        mov     a       p_delay3
        inca
        mov     p_delay3 a
        caje    #0000b  @@p_delay_ok
	jmp	@@delayp_end
@@p_delay_ok:
        mov     p_delay1 #0000b

        page0
;	mov	a	#1000b
	mov	a	#1100b
	and	a	ret_flag
	caje	#1000b	@@delayp_ok_ret2
	jmp	@@delayp_end
@@delayp_ok_ret2:
	page0
	mov	a	#0011b
	and	a	ret_flag
	mov	ret_flag	a
;	caje	#1000b	@@delayp_end

        page3
        ret2
@@delayp_end:
	Jmp	@@Check_Delay_Bk

;##########################################
;   -------- Check EZIO --------
;========================================
; check EZIO running
; if EZIO end, check FG or BG ret
; For FG & BG ret, check if EZIO ret or not
;----------------------------------------
Check_EZIO:
ifdef	@@_EZ_IO_@@
        page4
        mov	a	#0001b
        and	a	EZIO_flag
        caje	#0001b	@Check_EZIO_ok		;EZIO_flag.0=0 : eio end mark detected or force to stop / EZIO_flag.0=1 : EZIO keep going

	page0
	mov	a	#0010b			; EZIO is FG or not
	and	a	EZIO_FG
	page4
	
	caje	#0000b	@EZIO_ret2_check
	jmp	@EZIO_ret1_check

@EZIO_ret1_check:
	page0
	mov	a	#0011b
	and	a	Ret_flag
	caje	#0001b	@EZIO_ok_ret1
	jmp	@Check_EZIO_ok
@EZIO_ret2_check:
	page0
	mov	a	#1100b
	and	a	Ret_flag
	caje	#0100b	@EZIO_ok_ret2
	jmp	@Check_EZIO_ok
@EZIO_ok_ret1:
	page0
	mov	a	#1100b
	and	a	ret_flag
	mov	ret_flag	a
	page3
	ret1
@EZIO_ok_ret2:
	page0
	mov	a	#0011b
	and	a	ret_flag
	mov	ret_flag	a
  page3
	ret2
endif

@Check_EZIO_ok:
	Jmp	@@Check_EZIO_Bk

;##########################################
;   -------- Update_Output --------
;========================================
;
;----------------------------------------
Update_output:
	; ##########################################################
;       For IR function
;  IR_TRANSMIT.... Disable P3.3
;  IR_RECEIVE .... Disable P3.3
;  IR_Bidirection .... Disable P3.2 and P3.3
; ##########################################################
ifdef   IR_Transmit

ifdef   IR_Receive
        PAGE2
        MOV     A,#0011B
        AND     A,P3_GO1
        MOV     P3_GO1,A

        MOV     A,#1100B
        OR      A,P3_GO2
        MOV     P3_GO2,A
else
        PAGE2
        MOV     A,#0111B
        AND     A,P3_GO1
        MOV     P3_GO1,A

        MOV     A,#1000B
        OR      A,P3_GO2
        MOV     P3_GO2,A
endif

elseifdef       IR_Receive
        PAGE2
        MOV     A,#0111B
        AND     A,P3_GO1
        MOV     P3_GO1,A

        MOV     A,#1000B
        OR      A,P3_GO2
        MOV     P3_GO2,A
endif

        page0
        mov     a       p3_fva
        page2
        or      a       p3_fv1
        mov     p3_fv1  #0000b
        and     a       p3_go2
        page0
        mov     p3_fva  a
@@toggle_1_back:
	page2
        mov     a       #1111b
        xor     a       p1_go2
        caje    #0      @@updateP2
        page1
        mov     a       p1state
        page2
        and     a       p1_go2
        or      a       p1_go1
        page1
        mov     p1state a
        mov     p1      a
        
@@updateP2:        
        page2
        mov     a       p2_go2
        caje    #1111b  @@updateP3

;;;; For Drive & Sink function ;;;;;;;;;;;
        MOV     A,#1111B
        XOR     A,P2_GO2
        Page1
        OR      A ,P2S_STATE
;DIRECT KEY MASK 2002/6/12
        MOV	P2S_STATE ,A
        MOV	A ,KEYP2
        OR      A ,P2S_STATE
        
        MOV     P2S,A
        MOV     P2S_STATE,A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        page0
        mov     a       p2state
        page2
        and     a       p2_go2
        or      a       p2_go1
        page0
        mov     p2state a
        mov     p2      a
;;;; For Drive & Sink function ;;;;;;;;;;;
        PAGE2
        MOV     A,P2_GO2
        Page1
        AND     A,P2S_STATE
;DIRECT KEY MASK 2002/6/12
        MOV	P2S_STATE ,A
        MOV	A ,KEYP2
        OR      A ,P2S_STATE
        
        MOV     P2S,A
        MOV     P2S_STATE,A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
@@updateP3:
        page2
        mov     a       p3_go2
        caje    #1111b  @@updateDone

;;;; For Drive & Sink function ;;;;;;;;;;;
        MOV     A,#1111B
        XOR     A,P3_GO2
        Page1
        OR      A ,P3S_STATE
;DIRECT KEY MASK 2002/6/12
        MOV	P3S_STATE ,A
        MOV	A ,KEYP3
        OR      A ,P3S_STATE
        
        MOV     P3S,A
        MOV     P3S_STATE,A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        page0
        mov     a       p3state
        page2
        and     a       p3_go2
        or      a       p3_go1
        page0
        mov     p3state a
        mov     p3      a

;;;; For Drive & Sink function ;;;;;;;;;;;
        PAGE2
        MOV     A,P3_GO2
        Page1
        AND     A,P3S_STATE
;DIRECT KEY MASK 2002/6/12
        MOV	P3S_STATE ,A
        MOV	A ,KEYP3
        OR      A ,P3S_STATE
        
        MOV     P3S,A
        MOV     P3S_STATE,A

@@updateDone:
        page2
        mov     p2_go2  #1111b
        mov     p3_go2  #1111b
	Jmp	@@Update_output_Bk

Check_Event:
;============================================= new event mark & fv debounce ===============================
@@_normal_Mark:
	mov	a	FRA1			; bit2 of Fra1 is for fv flag
	page4
	mov	mask_fra1	a
	mov	a	#0100b		; 
	and	a	mask_fra1
	caje	#0000b	@update_fv
	jmp	@debounce_fv
@update_fv:
	mov	a	mask_fra1
	mov	fra1_flag	a
	mov	m4	#0000b
	jmp	@@event_check

@debounce_fv:
	mov	a	m4
	caje	#1111b	@update_fv
	jmp	@upcount

@upcount:
	mov	a	m4
	inca
	mov	m4	a
	jmp	@@event_check

@@event_check:

ifdef	@@_EZ_IO_@@
	page4
	mov	a	#0001b
	and	a	EventFlag
	caje	#0000b	@@chk_event_over
	mov	a	EZIO_flag
	caje	#0000b	@event_load
	mov	a	#1000b
	and	a	EZIO_flag
	caje	#0000b	@@chk_event_over	;	EZIO_flag.3=0 ==> no event mark
	mov	a	#0111b			;============ clayton 20080218 =====================
	and	a	EZIO_flag		;	clear Event mak flag (EZIO_flag.3) when event is read
	mov	EZIO_flag	a		;
	mov	a	EZ_MarkH
	mov	EZ_MarkH	#0000b
	caje	#0000b	@jmp_e0_e15
;	caje	#0001b	@jmp_e16_e31
;	caje	#0010b	@jmp_e32_e47
;	jmp	@jmp_e48_e63

@jmp_e0_e15:
	mov	a	EZ_Mark
	mov	EZ_Mark #0000b
	caje	#0000b	@@chk_event_over	;@@e0
	caje	#0001b	@@e1		
	caje	#0010b	@@e2		
	caje	#0011b	@@e3		
	caje	#0100b	@@e4		
	caje	#0101b	@@e5		
	caje	#0110b	@@e6		
	caje	#0111b	@@e7		
	caje	#1000b	@@e8		
	caje	#1001b	@@e9		
	caje	#1010b	@@e10		
	caje	#1011b	@@e11		
	caje	#1100b	@@e12		
	caje	#1101b	@@e13		
	caje	#1110b	@@e14		
	jmp	@@e15	
;@jmp_e16_e31:
;	mov	a	EZ_Mark
;	mov	EZ_Mark #0000b
;	caje	#0000b	@@e16
;	caje	#0001b	@@e17		
;	caje	#0010b	@@e18		
;	caje	#0011b	@@e19		
;	caje	#0100b	@@e20		
;	caje	#0101b	@@e21		
;	caje	#0110b	@@e22		
;	caje	#0111b	@@e23		
;	caje	#1000b	@@e24		
;	caje	#1001b	@@e25		
;	caje	#1010b	@@e26		
;	caje	#1011b	@@e27		
;	caje	#1100b	@@e28		
;	caje	#1101b	@@e29		
;	caje	#1110b	@@e30		
;	jmp	@@e31		
;@jmp_e32_e47:
;	mov	a	EZ_Mark
;	mov	EZ_Mark #0000b
;	caje	#0000b	@@e32
;	caje	#0001b	@@e33		
;	caje	#0010b	@@e34		
;	caje	#0011b	@@e35		
;	caje	#0100b	@@e36		
;	caje	#0101b	@@e37		
;	caje	#0110b	@@e38		
;	caje	#0111b	@@e39		
;	caje	#1000b	@@e40		
;	caje	#1001b	@@e41		
;	caje	#1010b	@@e42		
;	caje	#1011b	@@e43		
;	caje	#1100b	@@e44		
;	caje	#1101b	@@e45		
;	caje	#1110b	@@e46		
;	jmp	@@e47		
;@jmp_e48_e63:
;	mov	a	EZ_Mark
;	mov	EZ_Mark #0000b
;	caje	#0000b	@@e48
;	caje	#0001b	@@e49		
;	caje	#0010b	@@e50		
;	caje	#0011b	@@e51		
;	caje	#0100b	@@e52		
;	caje	#0101b	@@e53		
;	caje	#0110b	@@e54		
;	caje	#0111b	@@e55		
;	caje	#1000b	@@e56		
;	caje	#1001b	@@e57		
;	caje	#1010b	@@e58		
;	caje	#1011b	@@e59		
;	caje	#1100b	@@e60		
;	caje	#1101b	@@e61		
;	caje	#1110b	@@e62		
;	jmp	@@e63		

endif	

@event_load:
	page4
	mov	a	#0001b
	and	a	EventFlag
	caje	#0000b	@@chk_event_over
	mov	a	#0010b
	and	a	EventFlag		
	caje	#0010b	@@chk_event_over	       ;bit1=1 of EventFlag no read event mark 
	mov	a	Mark


@@_EZIO_Mark:
	caje	#0000b	@@chk_event_over
	caje	#0001b	@@e1		
	caje	#0010b	@@e2		
	caje	#0011b	@@e3		
	caje	#0100b	@@e4		
	caje	#0101b	@@e5		
	caje	#0110b	@@e6		
	caje	#0111b	@@e7		
	caje	#1000b	@@e8		
	caje	#1001b	@@e9		
	caje	#1010b	@@e10		
	caje	#1011b	@@e11		
	caje	#1100b	@@e12		
	caje	#1101b	@@e13		
	caje	#1110b	@@e14		
	jmp	@@e15		
@@chk_event_over:

	jmp	@@check_event_Bk

;##########################################
;   -------- Check Timer Routine --------
;========================================
;
;----------------------------------------
Check_Timer:
        cjc     @@4ms
        jmp     @@Check_Delay_OK
@@4ms:
                rstcf
ifdef	@@_EZ_Io_@@        
        JumpTo  Check_EZIO_delay
endif        
;        page0
		page2
        mov	a	deboc_count	; key debonce counter
        inca				; 4ms increase one time.
        mov	deboc_count	a	; It will be cleared when key changed.
        page0
        mov     a       #0100b
        xor     a       4mto8m
        mov     4mto8m  a
        mov     a       #0100b
        and     a       4mto8m
        caje    #0100b  @@Check_Delay_OK
@@8ms:  
	PAGE1
	mov	a	#0111B
	or	a	Delay_Flag
	mov	Delay_Flag	a
	
@@Check_Delay_OK:
	Jmp	@@Check_Timer_Bk
;##########################################
;   -------- Power Down Routine --------
;========================================
;
;----------------------------------------
;********** power down routine ok ********
Check_PowerDown:
ifdef   IR_Transmit
        PAGE4
        MOV     A,#0001B
        AND     A,IRout_ON_OFF_3_0
        CAJE    #0001B,@@scankey1
endif

ifdef	@@_EZ_IO_@@
	page4
	mov	a	#0001b
	and	a	EZIO_flag
	caje	#0001b	@@scankey1		; 20090115 clayton : EZIO function is running, so back to @@scankey1
endif

	page4
	mov	a	PWMIOEN1
	caje	#0	@@Power_down_chk
	jmp	@@scankey1
@@Power_down_chk:

        page1
        mov     a       delay8m
        caje    #0000b  @@no_delay
        jmp     @@scankey1
@@no_delay:
        mov     a       s_delay1
        caje    #0000b  @@no_s_delay
        jmp     @@scankey1
@@no_s_delay:
        page2
        mov     a       p_delay1
        caje    #0000b  @@no_p_delay
        jmp     @@scankey1
@@no_p_delay:
        page0
        mov     a       #0001b
        and     a       v_state
        caje    #0000b  @@pd_ready
        jmp     @@scankey1
@@no_bk:
	PAGE1
	MOV	A	BGROUND2
        page0
        caje    #0000b  @@pd_ready
        jmp     @@scankey1        
@@pd_ready:
        CJP    @@scankey1
        mov     a       #1000b
        and     a       4mto8m		;m14  check debounce flag 2005/5/30 04:43U
        caje    #1000b  @@scankey1

        mov     a       #0001b
        and     a       4mto8m		;m14 check head code flag 2005/5/30 04:43U
        caje    #0000b  @@power_down

        VolDown				; Add by Allan (1/3/05), downcount Volume to prevent "Bo".

 ; Turn OFF Push_Pull OP2
        mov	A,#0100B
        mov	mode1,a

        Play   sn1#xo.wav
         ;mov	m14	#0000b	;  \
        mov	a	#1110b	;   | modify 2005/5/30 03:46U 4mto8m share other flag
        and	a	4mto8m	;   |
        mov     4mto8m     a	;  /
@@wait_t:
        CJP    @@wait_t

        ; Turn OFF Push_Pull OP1 & OP2
        mov	A,#0000B
        mov	mode1,a
        
        page0
        ;mov	a,#0111b		;\
        mov	a,VolValue_Page0	 ;| Add by Allan (1/3/05), Restore Master Volume to MODE
        mov	mode,a			;/        
        
        jmp     @@scankey1
@@power_down:
        page0
        mov     a       mrx
        caje    #1111b  @@pd_key0_
@@pd_scan0:
        mov     KeyID     #0001b                  ;KeyID: scan loop
        jmp     @@pd_trig_scan
@@pd_scan0_back:
        mov     a       p1
        xor     a       tr1_4
	caje	#0000b	@@pd_scan1
        jmp     @@trig_chk
@@pd_scan1:
        mov     KeyID     #0010b                  ;KeyID: scan loop
        jmp     @@pd_trig_scan
@@pd_scan1_back:
        mov     a       p1
        xor     a       tr5_8
	caje	#0000b	@@pd_scan2
        jmp     @@trig_chk
@@pd_scan2:
        mov     KeyID     #1000b
        mov     a       mrx
        caje    #1100b  @@pd_scan_ok
        mov     KeyID     #0100b                  ;KeyID: scan loop
        jmp     @@pd_trig_scan
@@pd_scan2_back:
        mov     a       p1
        xor     a       tr9_12
	caje	#0000b	@@pd_scan3
        jmp     @@trig_chk
@@pd_scan3:
        mov     KeyID     #1000b
        mov     a       mrx
        caje    #1000b  @@pd_scan_ok
        jmp     @@pd_trig_scan
@@pd_scan3_back:
        mov     a       p1
        xor     a       tr13_16
	caje	#0000b	@@pd_scan_ok
        jmp     @@trig_chk

@@pd_scan_ok:
ifdef	@_key_type_@				;add at 05-26'04 for mix key
@@pd_Mkeyp2:
	page0	
        mov     a       p2
        mov     KeyID     a
        mov     a       keyp2
        and     a       KeyID
	mov	KeyID	#0011b
	xor     a       Mtr2
        caje	#0000b	@@pd_Mkeyp3	         
        jmp     @@trig_chk

@@pd_Mkeyp3:
	page0	
        mov     a       p3
        mov     KeyID     a
        mov     a       keyp3
        and     a       KeyID
        mov     KeyID     #0111b
	xor     a       Mtr3
	caje	#0000b	@@pd_scankey_ok
        jmp     @@trig_chk
endif
	jmp	@@pd_scankey_ok

@@pd_key0_:
	page0
        mov     a       p1
        mov     KeyID     a
        mov     a       keyp1
        and     a       KeyID
        mov     KeyID     #0001b
        xor     a       tr1_4
	caje	#0000b	@@pd_key1_
        jmp     @@trig_chk
@@pd_key1_:
        mov     a       p2
        mov     KeyID     a
        mov     a       keyp2
        and     a       KeyID
        mov     KeyID     #0010b
        xor     a       tr5_8
	caje	#0000b	@@pd_key2_
        jmp     @@trig_chk
@@pd_key2_:
        mov     a       p3
        mov     KeyID     a
        mov     a       keyp3
        MOV     TEMP2_0,#1111B
ifdef   IR_Transmit
ifdef   IR_Receive
;;;   IR_Bidirection
        
        MOV     TEMP2_0,#0011B
else
;;;; IR_TRANSMIT
        
        MOV     TEMP2_0,#0111B
endif
elseifdef       IR_Receive
;;;;;   IR_RECEIVE
        
        MOV     TEMP2_0,#0111B
endif
        and     a       KeyID
        mov     KeyID     #0100b
        xor     a       tr9_12
	caje	#0000b	@@pd_scankey_ok
        jmp     @@trig_chk

@@pd_scankey_ok:
;;;; For Drive & Sink function ;;;;;;;;;;;
        Page1
        MOV     A,P2S_STATE
        MOV     P2S,A
        MOV     A,P3S_STATE
        MOV     P3S,A
        PAGE0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;   page0
    ;   mov     a       #1111b
    ;   mov     p2s     a
    ;   mov     p3s     a
;;;; Scankey P2-->P1  ;;;;;;;;;;
        mov     a       mrxb
        or      a       p2state
;ifdef	@_key_type_@				;add at 05-26'04 for mix key
;	mov	p2state	a
;	mov	a	keyp2
;	and	a	p2state
;endif	  
        mov     p2      a
        mov     p2state a
        mov     m15     #0000b
        end
;******* trigger scan routine ok*****************


;##########################################
;   -------- ScanKey  --------
;========================================
; If M6=1xxx, It will stop scan new line.
; Just repeat doing Debonce only.
; If (mrx=#1111B), it will enter direct
; trigger mode.
;----------------------------------------
ScanKey:
        page0
        mov     a       #1000b
        and     a       4mto8m		;m14  check bounce 2005/5/30 04:45U
        caje    #1000b  Check_Debounce
        
        page0
        mov     a       mrx
        caje    #1111b  @@key0_

;==================================
;=  ------ Scan P2.0-->P1 ------  =
;==================================
@@scan0:
        mov     KeyID     #0001b                  ;KeyID: scan loop
        jmp     @@trig_scan
@@scan0_back:
        mov     a       p1
        xor     a       tr1_4
        jmp     @@trig_chk
;==================================
;=  ------ Scan P2.1-->P1 ------  =
;==================================
@@scan1:
        mov     KeyID     #0010b                  ;KeyID: scan loop
        jmp     @@trig_scan
@@scan1_back:
        mov     a       p1
        xor     a       tr5_8
        jmp     @@trig_chk
;==================================
;=  ------ Scan P2.2-->P1 ------  =
;==================================
@@scan2:
        mov     KeyID     #1000b
        mov     a       mrx
        caje    #1100b  @@mrx
        mov     KeyID     #0100b                  ;KeyID: scan loop
        jmp     @@trig_scan
@@scan2_back:
        mov     a       p1
        xor     a       tr9_12
        jmp     @@trig_chk
;==================================
;=  ------ Scan P2.3-->P1 ------  =
;==================================
@@scan3:
        mov     KeyID     #1000b
        mov     a       mrx
        caje    #1000b  @@mrx
        jmp     @@trig_scan
@@scan3_back:
        mov     a       p1
        xor     a       tr13_16
        jmp     @@trig_chk

;##########################################
; -------- ScanKey output Routine --------
;========================================
; Input: Pg0 KeyID. (Data will output to P2)
;----------------------------------------
@@trig_scan:
;;;; Scankey P2-->P1 ;;;;;;;;;
        page0
        mov     a       p2state
        or      a       KeyID
        mov     p2      a
        mov     a       mrx
        mov     p2s     a
        mov     a       #1111b
        mov     p2s     a
        mov     a       KeyID
        caje    #0001b  @@scan0_back
        caje    #0010b  @@scan1_back
        caje    #0100b  @@scan2_back
        caje	#1000b  @@scan3_back
	jmp	@@scankey1		; This line will not happened.

;==================================
;=  _---- Power Down Check _----  =
;==================================
@@pd_trig_scan:					;add at 03/23/04
;;;; Scankey P2-->P1 ;;;;;;;;;
        page0
        mov     a       p2state
        or      a       KeyID
        mov     p2      a
        mov     a       mrx
        mov     p2s     a
        mov     a       #1111b
        mov     p2s     a
        mov     a       KeyID
        caje    #0001b  @@pd_scan0_back
        caje    #0010b  @@pd_scan1_back
        caje    #0100b  @@pd_scan2_back
        caje	#1000b  @@pd_scan3_back
	jmp	@@scankey1		; This line will not happened.

;##########################################
; -------- Direct Trigger Routine --------
;========================================
;----------------------------------------
@@key0_:
        mov     a       p1
        mov     KeyID     a
        mov     a       keyp1
        and     a       KeyID
        mov     KeyID     #0001b
        xor     a       tr1_4
        jmp     @@trig_chk
@@key1_:
        mov     a       p2
        mov     KeyID     a
        mov     a       keyp2
        and     a       KeyID
        mov     KeyID     #0010b
        xor     a       tr5_8
        jmp     @@trig_chk
@@key2_:
        mov     a       p3
        mov     KeyID     a
        mov     a       keyp3
        and     a       KeyID
        mov     KeyID     #0100b
        xor     a       tr9_12
        jmp     @@trig_chk


ifdef	@_key_type_@				;add at 05-26'04 for mix key
@@Mkeyp2_:
	page0	
        mov     a       p2
        mov     KeyID     a
        mov     a       keyp2
        and     a       KeyID
	mov	KeyID	#0011b
	
        xor     a       Mtr2
	jmp	@@trig_chk
@@Mkeyp3_:
	page0	
        mov     a       p3
        mov     KeyID     a
        mov     a       keyp3
        and     a       KeyID
        mov     KeyID     #0111b
	
        xor     a       Mtr3
	jmp	@@trig_chk
endif


;##########################################
;   -------- Trigger Check --------
;========================================
; Input A: If A doesn't equal to zero,
; it will set M6.3 for enable debouce
; routine.
;----------------------------------------
@@trig_chk:
        page0
        caje    #0000b  @@mrx
        mov     m15     a                       ;m15:trigger change condition
        
        mov     a       #1000b                  ;m6.3=1,debounce
        and     a       4mto8m			;m14 2005/5/30 04:45U
        caje	#1000b	@@ScanKey_BK
        
        mov     a       #1000b                  ;m6.3=1,debounce
        or      a       4mto8m			;m14
        mov     4mto8m     a
		page2        
        mov	deboc_count	#0		;clear debonce counter.
		page0
	Jmp	@@ScanKey_BK

@@mrx:
	JumpTo	Check_Speech
	page0
        mov     a       #0111b
        and     a       4mto8m			;m14 clr bounce 2005/5/30 04:46U
        mov     4mto8m     a			;2005/5/30 04:47U
		page2
        mov     deboc_count	#0
		page0
        mov     a       mrx
        caje    #1111b  @@chk_direct_key
        page0
        mov     a       KeyID
        caje    #0001b  @@scan1
        caje    #0010b  @@scan2
        caje	#0100b  @@scan3
ifdef	@_key_type_@				;add at 05-26'04 for mix key			  	
	caje	#1000b	@@Mkeyp2_
	caje	#0011b	@@Mkeyp3_
endif
	;jmp	@@timer_ok
	Jmp	@@ScanKey_BK



;##########################################
;   -------- Debonce Routine --------
;========================================
;----------------------------------------
Check_Debounce:
	;page0
		page2
        mov     a       deboc_count
        page0
        caje    deboc	@@tr_cg_ok

        mov     a       mrx
        caje    #1111b  @@trig_key_ret
        mov     a       KeyID
        caje    #0001b  @@scan0
        caje    #0010b  @@scan1
        caje    #0100b  @@scan2
	caje	#1000b	@@scan3
ifdef	@_key_type_@				;add at 05-26'04 for mix key
	caje	#0011b	@@Mkeyp2_
	caje	#0111b	@@Mkeyp3_
endif 
        jmp     @@ScanKey_BK
@@trig_key_ret:
        mov     a       KeyID
        caje    #0001b  @@key0_  ; p1
        caje    #0010b  @@key1_  ; p2
        jmp     @@key2_          ; p3
;******* scankey routine ok ********************

@@tr_cg_ok:
        ;page0
        page2
        mov     deboc_count	#0		; Reset Debounce counter
        page0
        mov     a       #0111b			; Clear Debounce Flag
        and     a       4mto8m			;m14 2005/5/30 04:48U
        mov     4mto8m     a
        
        mov     a       #0001b			; M15 = XXX1 ? 
        and     a       m15
        caje    #0001b  @@p1ok
        
        mov     a       #0010b			; M15 = XX1X ?
        and     a       m15
        caje    #0010b  @@p1ok
        
        mov     a       #0100b			; M15 = X1XX ?
        and     a       m15
        caje    #0100b  @@p1ok
        
        mov     a       #1000b			; Else, Set M15 = 1000
@@p1ok: mov     m15     a			; M15 is used to UPDATE BIT.
        mov     a       KeyID
        caje    #0001b  @@update_mrx_0
        caje    #0010b  @@update_mrx_1
        caje    #0100b  @@update_mrx_2
	caje	#1000b	@@update_mrx_3
ifdef	@_key_type_@				;add at 05-26'04 for mix key	
	caje	#0011b	@@update_MixedKeyP2
	caje	#0111b	@@update_MixedKeyP3
@@update_MixedKeyP3:
	mov     a       Mtr3
	xor	a	m15
	mov     Mtr3  a
	jmp	@@change

@@update_MixedKeyP2:
	mov     a       Mtr2
	xor	a	m15
	mov     Mtr2	a
        jmp     @@change
endif
@@update_mrx_3:
        mov     a       tr13_16
        xor     a       m15
        mov     tr13_16 a
        jmp     @@change
@@update_mrx_2:
        mov     a       tr9_12
        xor     a       m15
        mov     tr9_12  a
        jmp     @@change
@@update_mrx_1:
        mov     a       tr5_8
        xor     a       m15
        mov     tr5_8   a
        jmp     @@change
@@update_mrx_0:
        mov     a       tr1_4
        xor     a       m15
        mov     tr1_4   a
	jmp	@@change
@@change:
	page0
        and     a       m15
        caje    #0000b  @@trh2l_run
        jmp     @@trl2h_run

;##########################################
;   -------- Check_Direct_Key --------
;========================================
;----------------------------------------
@@chk_direct_key:
        mov     a       KeyID
        ;caje    #0100b  @@timer_ok
        caje    #0100b	@@ScanKey_BK
        caje    #0001b  @@key1_
        jmp     @@key2_
@@trl2h_run:
        mov     a       KeyID
        caje    #0001b  @@tr1_4r
        caje    #0010b  @@tr5_8r
        caje    #0100b  @@tr9_12r
        caje	#1000b  @@tr13_16r
ifdef	@_key_type_@				;add at 05-26'04 for mix key
	caje	#0011b	@@Mtr2r
	caje	#0111b	@@Mtr3r
endif
	jmp	@@scankey1
@@tr1_4r:
        mov     a       m15
        page3
        caje    #0001b  @@tr1r
        caje    #0010b  @@tr2r
        caje    #0100b  @@tr3r
        jmp     @@tr4r
@@tr5_8r:
        mov     a       m15
        page3
        caje    #0001b  @@tr5r
        caje    #0010b  @@tr6r
        caje    #0100b  @@tr7r
        jmp     @@tr8r
@@tr9_12r:
        mov     a       m15
        page3
        caje    #0001b  @@tr9r
        caje    #0010b  @@tr10r
        caje    #0100b  @@tr11r
        jmp     @@tr12r
@@tr13_16r:
        mov     a       m15
        page3
        caje    #0001b  @@tr13r
        caje    #0010b  @@tr14r
        caje    #0100b  @@tr15r
        jmp     @@tr16r

ifdef	@_key_type_@				;add at 05-26'04 for mix key
@@Mtr2r:
        mov     a       m15
        caje    #0001b  @@Mtr2_0r
        caje    #0010b  @@Mtr2_1r
        caje    #0100b  @@Mtr2_2r
        caje	#1000b  @@Mtr2_3r
	jmp	@@scankey1
@@Mtr3r:
        mov     a       m15
        caje    #0001b  @@Mtr3_0r
        caje    #0010b  @@Mtr3_1r
        caje    #0100b  @@Mtr3_2r
        caje	#1000b  @@Mtr3_3r
	jmp	@@scankey1
endif

@@trh2l_run:
        mov     a       KeyID
        caje    #0001b  @@tr1_4f
        caje    #0010b  @@tr5_8f
        caje    #0100b  @@tr9_12f
	caje	#1000b  @@tr13_16f
ifdef	@_key_type_@				;add at 05-26'04 for mix key
	caje	#0011b	@@Mtr2f
	caje	#0111b	@@Mtr3f
endif
	jmp	@@scankey1

@@tr1_4f:
        mov     a       m15
        page3
        caje    #0001b  @@tr1f
        caje    #0010b  @@tr2f
        caje    #0100b  @@tr3f
        jmp     @@tr4f
@@tr5_8f:
        mov     a       m15
        page3
        caje    #0001b  @@tr5f
        caje    #0010b  @@tr6f
        caje    #0100b  @@tr7f
        jmp     @@tr8f
@@tr9_12f:
        mov     a       m15
        page3
        caje    #0001b  @@tr9f
        caje    #0010b  @@tr10f
        caje    #0100b  @@tr11f
        jmp     @@tr12f
@@tr13_16f:
        mov     a       m15
        page3
        caje    #0001b  @@tr13f
        caje    #0010b  @@tr14f
        caje    #0100b  @@tr15f
        jmp     @@tr16f

ifdef	@_key_type_@				;add at 05-26'04 for mix key
@@Mtr2f:
        mov     a       m15
        caje    #0001b  @@Mtr2_0f
        caje    #0010b  @@Mtr2_1f
        caje    #0100b  @@Mtr2_2f
        caje	#1000b  @@Mtr2_3f
	jmp	@@scankey1
@@Mtr3f:
        mov     a       m15
        caje    #0001b  @@Mtr3_0f
        caje    #0010b  @@Mtr3_1f
        caje    #0100b  @@Mtr3_2f
        caje	#1000b  @@Mtr3_3f
	jmp	@@scankey1
endif


;**********************************************
;##########################################
;   -------- Random Routine --------
;========================================
;----------------------------------------
Check_Random:
        page2
        mov     a       Rand0Max
        caje    #0      @@ChkRand1
        mov     a       Rand0
        caje    Rand0Max @@RstRand0
        inca
        mov     Rand0   a
        jmp     @@Check_Random_Bk
@@RstRand0:
        mov     Rand0   #0
@@ChkRand1:
        mov     a       Rand1Max
;        caje    #0      @@ChkRand2
        caje    #0      @@Check_Random_Bk
        mov     a       Rand1
        caje    Rand1Max @@RstRand1
        inca
        mov     Rand1   a
        jmp     @@Check_Random_Bk
@@RstRand1:
        mov     Rand1   #0
;@@ChkRand2:
;        mov     a       Rand2Max
;        caje    #0      @@Check_Random_Bk
;        mov     a       Rand2
;        caje    Rand2Max @@RstRand2
;        inca
;        mov     Rand2   a
;        jmp     @@Check_Random_Bk
;@@RstRand2:
;        mov     Rand2   #0
        jmp     @@Check_Random_Bk


;#################################################################
;###############  Function Call for EZ program.   ################
;#################################################################

;##########################################
;   -------- Check Voice Play --------
;========================================
;
;----------------------------------------
@@chk_voc1:                       ;ch1,Play
	page4
ifdef  @@_EZ_IO_@@	
        mov	a	#0100b
        and	a	EZIO_flag
        caje	#0100b	@f
	DisableEZIO_@@
@@:	
endif
	mov	Next_flag #0
	mov	a	#0
	mov	next	a
	mov	nxtply	a
        page0
        mov     a       #0001b
        and     a       4mto8m		;m14 2005/5/30 04:48U head code
        caje    #0001b  @@s_h_ok1

         ; Turn ON Push_Pull OP1
        mov	A,#0100B
        mov	mode1,a

        Play   sn0#xo.wav
@@wait_s_h1:
        CJP    @@wait_s_h1
        
        ; Turn ON Push_Pull OP1 & OP2
        mov	A,#1100B
        mov	mode1,a
        
        mov     a       #0001b
        or      a       4mto8m		;m14 2005/5/30 04:49U set head code flag
        mov     4mto8m     a
@@s_h_ok1:
        VolDown				;\ 
;        Play   sil#xo.wav		 ;| Add by Allan (1/3/05), downcount Volume to
;@@Silence_NotOK1:			 ;| prevent "Bo".
;	cjp	@@Silence_NotOK1	;/
	
        page0
        ;mov	a,#0111b		;\
        mov	a,VolValue_Page0	 ;| Add by Allan (1/3/05), Restore Master Volume to MODE
        mov	mode,a			;/
	
	
	
        mov     a       #0001b
        or      a       v_state
        mov     v_state a
        page1
        mov     delay8m #0000b

        page3
        ret1

;##########################################
;   -------- Clear Enter B routine --------
;========================================
;
;----------------------------------------
;*********************************
@@clear_enter_b1:
        page2
        mov     a       #1011b
        and     a       enter_b
        mov     enter_b a
        ret1
;*********************************
@@clear_enter_b2:
        page2
        mov     a       #0111b
        and     a       enter_b
        mov     enter_b a
        ret1
;*********************************
@@clear_enter_p1:
        page2
        mov     a       #1011b
        and     a       enter_b
        mov     enter_b a
        ret2
;*********************************
@@clear_enter_p2:
        page2
        mov     a       #0111b
        and     a       enter_b
        mov     enter_b a
        ret2
;**********************************************

;##########################################
;   -------- Check Voice P1  --------
;========================================
;
;----------------------------------------
@@chk_voc_P1:                       ;ch1,background Play
	DisableEZIO_@@
	page4
	mov	Next_flag #0
	mov	a	#0
	mov	next	a
	mov	nxtply	a
        page0
        mov     a       #0001b
        and     a       4mto8m		;m14 2005/5/30 04:49U head code
        caje    #0001b  @@s_h_ok_p1

        ; Turn ON Push_Pull OP1
        mov	A,#0100B
        mov	mode1,a

        Play   sn0#xo.wav
@@wait_s_h_p1:
        CJP    @@wait_s_h_p1
        
        ; Turn ON Push_Pull OP1 & OP2
        mov	A,#1100B
        mov	mode1,a
        
        mov     a       #0001b
        or      a       4mto8m		;m14 2005/5/30 04:50U set head code
        mov     4mto8m     a

@@s_h_ok_p1:
        mov     a       #0001b
        or      a       v_state
        mov     v_state a
        page2
        mov     p_delay1 #0000b
        page3
        ret2

;##########################################
;   -------- Stop Pb  --------
;========================================
;
;----------------------------------------
@@stop_pb:
        page0
        mov     a       #0101b
        and	a	v_state
        caje    #0000b  @@no_s
        mov     a       #0100b
        and     a       v_state
        caje    #0100b  @@js_stv1
        jmp     @@no_ss
@@js_stv1:
        ;mov     a       #0101b
        ;and     a       v_state
        ;mov     v_state a
        stop
        Play   sil#xo.wav
        jmp     @@no_s1
@@no_s1:

        mov     a       #1011b
        and     a       v_state
        mov     v_state a
        jmp     @@no_ss
@@no_s:
        mov     a       #1110b
        and     a       v_state
        mov     v_state a
@@no_ss:
        page2
        mov     p_delay1 #0000b
        page3
        ret2

;##########################################
;   -------- Stop  --------
;========================================
; force all stop
;----------------------------------------
@@stop:
	DisableEZIO_@@
        page0
        mov	a	#0000b
        mov	ret_flag	a	; clear Play & delay & ezio ret_flag
	page4
	mov	Next_flag #0
	mov	a	PWMIOEN1
	mov	PWMIOEN1 #0
	page0
	xor	a	p3state
	mov	p3state	a
	
	mov	a	#0
	mov	PIO_en	a
	
        page0
        mov     a       #0101b
        and	a	v_state
        caje    #0000b  @@nov
        VolDown				;\ 	
        stop
        Play   sil#xo.wav		 ;| Add by Allan (1/3/05), downcount Volume to
@@Silence_NotOK:			 ;| prevent "Bo".
	cjp	@@Silence_NotOK		;/
@@nov:
        mov	a	#1010b
        and	a	v_state
        mov     v_state	a
        page1
        mov     delay8m #0000b
        mov     s_delay1 #0000b
	mov	BGround1	#0000b		;add at 03/17'04 for clear background output		
	mov	BGround2        #0000b		;add at 03/17'04 for clear background output
        page2
        mov     p_delay1 #0000b
        mov     enter_b #0000b
        page0
        ;mov	a,#0111b		;\
        mov	a,VolValue_Page0	 ;| Add by Allan (1/3/05), Restore Master Volume to MODE
        mov	mode,a			;/

        page3
        ret1

;##########################################
;   -------- Stop V --------
;========================================
; force all voice stop
;----------------------------------------
@@stop_v:
	DisableEZIO_@@
        page0
;// clr ezio ret_flag if ezio ret is active
        mov	a	#1100b
        and	a	ret_flag
        caje	#0100b	@clr_bg_ezio
        jmp	@check_fg_ezio
@clr_bg_ezio:
	mov	a	#0011b
	and	a	ret_flag
	mov	ret_flag	a
@check_fg_ezio:
        mov	a	#0011b
        and	a	ret_flag
        caje	#0001b	@clr_fg_ezio
        jmp	@stop_v_2
@clr_fg_ezio:
	mov	a	#1100b
	and	a	ret_flag
	mov	ret_flag	a
;//////////////////////////////////////////////////
@stop_v_2:
        mov	a	#0101b
        and	a	v_state
        caje    #0000b  @@no_allvoice
        stop
        Play   sil#xo.wav
@@no_allvoice:
	mov	a	#1010b
	and	a	v_state
        mov     v_state	a
        page2
        mov     p_delay1 #0000b
        mov     enter_b #0000b
        page3
        ret1
;##########################################
;   -------- Stop  O --------
;========================================
; force background output stop
;----------------------------------------
@@stop_o1:
        page1
        mov     s_delay1        #0000b
	mov	BGround1	#0000b		;add at 03/17'04 for clear background output		
	mov	BGround2        #0000b		;add at 03/17'04 for clear background output
        page3
        ret3
@@stop_o2:
        page1
        mov     s_delay1        #0000b
	mov	BGround1	#0000b		;add at 03/17'04 for clear background output		
	mov	BGround2        #0000b		;add at 03/17'04 for clear background output
        page3
        ret3
;*************************************************************

;##########################################
;   -------- TailXO  --------
;========================================
;
;----------------------------------------

@@tailXO:                       ;only in ch1(not in path background)

        page0
        mov     a       #0001b
        and     a       4mto8m		;m14 2005/5/30 04:50U head code
        caje    #0000b,@@no_tail

 ; Turn OFF Push_Pull OP2
        mov	A,#0100B
        mov	mode1,a

        Play   sn1#xo.wav

        mov     a       #1110b
        and     a       4mto8m		;m14 2005/5/30 04:50U clr head code
        mov     4mto8m     a 		;2005/5/30 04:51U
@@wait_t2:
        CJP    @@wait_t2
        
        ; Turn OFF Push_Pull OP1 & OP2
        mov	A,#0000B
        mov	mode1,a
@@no_tail:
        page3
        ret1


;#######################################################################
;       IR Function
;#######################################################################

;##################################################################
;       MACRO
;##################################################################
;--------------------------------------------------------------
;--------------------------------------------------------------
;;;; 1ms
@@@RECEIVE_1ms  MACRO
        @@@DELAY_500us
        @@@DELAY_500us
        MOV    A,P3
        ENDM

;--------------------------------------------------------------
;--------------------------------------------------------------
;;; 700 / 4 === 175
; 1+13*12+12+6 =175
@@@RECEIVE_700us          MACRO
        page1
        MOV     Time_Counter , #0011b ;_INV_700us   ; 3
@@:
        NOP                        ; 1
        NOP                        ; 1
        NOP                        ; 1
        NOP                        ; 1
        NOP                        ; 1
        NOP                        ; 1
        MOV     A,Time_Counter   ; 1
        INCA                       ; 1
        MOV     Time_Counter,A   ; 1
        CAJE    #0,@F              ; 3
        JMP     @B                 ; 2
@@:
        NOP                        ; 1
        NOP                        ; 1
        NOP                        ; 1
        NOP                        ; 1
        ;NOP                        ; 1
        MOV    A,P3                ; 1
        ENDM


;--------------------------------------------------------------
;--------------------------------------------------------------
;; 500 us / 4 =125
@@@DELAY_500us  MACRO
	page1 			; 20080409 clayton
        MOV     Time_Counter #0001b;,_INV_500us    ; 1
@@:
        MOV     A,Time_Counter   ; 1
        INCA                       ; 1
        MOV     Time_Counter,A   ; 1
        CAJE    #0,@F              ; 3
        JMP     @B                 ; 2
@@:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        ENDM



;--------------------------------------------------------------
;--------------------------------------------------------------
@@@IR_RX_DATA     MACRO   VALUE,MEM
        @@@RECEIVE_1ms
        page0
        AND     A,TEMP2_0
        page4				;modify by John
        CAJE    #0,@F
        MOV     A,VALUE
        OR      A,MEM
        MOV     MEM,A
@@:
        JMP     @Ready_RECEIVE_IR_AGAIN
        ENDM


;--------------------------------------------------------------
;--------------------------------------------------------------
@@@Send_Carrier       MACRO
        MOV     A,#0111B
        MOV     P3S,A
        PAGE0
        MOV     A,#1000B
        OR      A,p3state
        MOV     P3,A
        PAGE1
        ENDM


;--------------------------------------------------------------
;--------------------------------------------------------------
@@@Send_Low           MACRO
        PAGE0
        MOV     A,#0111B
        AND     A,p3state
        MOV     P3,A
        PAGE1
        ENDM


@@@DETERMINE_IR_RX_DATA   MACRO  NAME
;-------------------------------------------------
;       Receive Data = 0E? H
;-------------------------------------------------
@@RECEIVE_H&NAME:
        MOV     A,RECEIVE_L
        CAJE    #00H , @@RECEIVE_H&NAME&L0
        CAJE    #01H , @@RECEIVE_H&NAME&L1
        CAJE    #02H , @@RECEIVE_H&NAME&L2
        CAJE    #03H , @@RECEIVE_H&NAME&L3
        CAJE    #04H , @@RECEIVE_H&NAME&L4
        CAJE    #05H , @@RECEIVE_H&NAME&L5
        CAJE    #06H , @@RECEIVE_H&NAME&L6
        CAJE    #07H , @@RECEIVE_H&NAME&L7
        CAJE    #08H , @@RECEIVE_H&NAME&L8
        CAJE    #09H , @@RECEIVE_H&NAME&L9
        CAJE    #0AH , @@RECEIVE_H&NAME&LA
        CAJE    #0BH , @@RECEIVE_H&NAME&LB
        CAJE    #0CH , @@RECEIVE_H&NAME&LC
        CAJE    #0DH , @@RECEIVE_H&NAME&LD
        CAJE    #0EH , @@RECEIVE_H&NAME&LE
        JMP            @@RECEIVE_H&NAME&LF
        ENDM







;#####################################################################
;#####################################################################
;#####################################################################
;#####################################################################
ifdef   IR_Transmit

;;; 6ms  ...... Start bit
;;;
;;; ###### SEND IR !!! ######
;;; ###### SEND IR !!! ######
;;; ###### SEND IR !!! ######
;; INPUT :   TRANS_H,TRANS_L


@IR_TRANSMIT:
        PAGE4
        MOV     A,#0001B
        AND     A,IRout_ON_OFF_3_0
        CAJE    #0,@IR_TRANSMIT_OK
;;;;;;;; 6 ms carrier ..... receive "L"
@SEND_IR_START:
;;;;;;;; start bit
;;;;;;; 500 us * 12 =  6 ms
        @@@Send_Carrier
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
        @@@DELAY_500us
	
        MOV     TRANS_COUNT_1,#0
@IR_TRANSMIT_AGAIN:
        MOV     A,TRANS_COUNT_1
        INCA
        MOV     TRANS_COUNT_1,A
        PAGE4
        CAJE    #1  , @IS_IR_TRANS_H1
        CAJE    #2  , @IS_IR_TRANS_H2
        CAJE    #3  , @IS_IR_TRANS_H3
        CAJE    #4  , @IS_IR_TRANS_H4
        CAJE    #5  , @IS_IR_TRANS_L1
        CAJE    #6  , @IS_IR_TRANS_L2
        CAJE    #7  , @IS_IR_TRANS_L3
        CAJE    #8  , @IS_IR_TRANS_L4

        
        MOV     A,#1110B
        AND     A,IRout_ON_OFF_3_0
        MOV     IRout_ON_OFF_3_0,A

        PAGE0
        MOV     A,P3STATE
        MOV     P3,A
        MOV     A,#1111B
        MOV     P3S,A
        JMP     @IR_TRANSMIT_OK


@IS_IR_TRANS_L4:
        MOV     A,#0001B
        JMP     @IS_IR_TRANS_L
@IS_IR_TRANS_L3:
        MOV     A,#0010B
        JMP     @IS_IR_TRANS_L
@IS_IR_TRANS_L2:
        MOV     A,#0100B
        JMP     @IS_IR_TRANS_L
@IS_IR_TRANS_L1:
        MOV     A,#1000B
@IS_IR_TRANS_L:
        AND     A,TRANS_L
        JMP     @READY_TO_TRANS_IR

@IS_IR_TRANS_H4:
        MOV     A,#0001B
        JMP     @IS_IR_TRANS_H
@IS_IR_TRANS_H3:
        MOV     A,#0010B
        JMP     @IS_IR_TRANS_H
@IS_IR_TRANS_H2:
        MOV     A,#0100B
        JMP     @IS_IR_TRANS_H
@IS_IR_TRANS_H1:
        MOV     A,#1000B
@IS_IR_TRANS_H:
        AND     A,TRANS_H
@READY_TO_TRANS_IR:
        CAJE    #0,@IR_SEND_0
        JMP     @IR_SEND_1
@IR_SEND_0:
        @@@Send_Low
        @@@Delay_500us
        @@@Send_Carrier
        @@@Delay_500us
        @@@Delay_500us
        @@@Delay_500us
        JMP     @IR_TRANSMIT_AGAIN

@IR_SEND_1:
        @@@Send_Low
        @@@Delay_500us
        @@@Delay_500us
        @@@Delay_500us
        @@@Send_Carrier
        @@@Delay_500us
        JMP     @IR_TRANSMIT_AGAIN

endif



ifdef   IR_Receive
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;      IR  receive mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
@IR_RECEIVE:
        PAGE4
        mov     a,#0100b
        and     a,IRin_ON_OFF_3_2
        caje    #0100B,@F

        MOV     A,#1101B
        AND     A,TRIGGER_FLAG_3_1
        MOV     TRIGGER_FLAG_3_1,A
        JMP     @IR_RECEIVE_OK
@@:
        
        MOV     RECEIVE_L,#0
        MOV     RECEIVE_H,#0

;;; ###### RECEIVE IR !!! ######
@@WWAIT_WAKEUP_SIGNAL:
	page0
;;?????????????????
;;      RX= P3.3 or P3.2
        MOV     TEMP2_0,_RX_DATA
;;?????????????????

        MOV     A,P3
        AND     A,TEMP2_0
        CAJE    #0,@MMAYBE_HEAD
        JMP     @SKIP_RECEIVE_IR
@MMAYBE_HEAD:

        PAGE4
        mov     a,#0010b
        and     a,TRIGGER_FLAG_3_1
        caje    #0,@f
;;;;;; DELAY FOR WAKE-UP
;; warm_up time= 4 ms
;;;;; 550 us * (16-14)= 1100 us
        MOV     A,#1101B
        AND     A,TRIGGER_FLAG_3_1
        MOV     TRIGGER_FLAG_3_1,A
        page1
        MOV     RECEIVE_COUNT_1,#14
        JMP     @WAIT_START_SIGNAL

@@:
;;;;;;; 550 us * (16-8)
        page1
        MOV     RECEIVE_COUNT_1,#8
@WAIT_START_SIGNAL:
        @@@DELAY_500us
        MOV     A,RECEIVE_COUNT_1
        INCA
        MOV     RECEIVE_COUNT_1,A
        CAJE    #0,@READY_TO_RECEIVE_IR
        MOV     A,P3
        page0
        AND     A,TEMP2_0
        page1
        CAJE    #0,@WAIT_START_SIGNAL
@SKIP_RECEIVE_IR:
        JMP     @IR_RECEIVE_OK

@READY_TO_RECEIVE_IR:
  ;     @@@DELAY_500us
        MOV    A,P3
        page0
        AND     A,TEMP2_0
        CAJE    #0,@TO_RECEIVE_IR
        JMP     @@WWAIT_WAKEUP_SIGNAL

@TO_RECEIVE_IR:
;;;;;;;; First receive IR  ;;;;;;;;;;;;;;;
;;;;;;;; First receive IR  ;;;;;;;;;;;;;;;
;;;;;;;; First receive IR  ;;;;;;;;;;;;;;;

	page1
        MOV     RECEIVE_COUNT_1,#0
;;;;;;;;;;;;;; DATA 1
@RECEIVE_IR_AGAIN:
@@:
        MOV     A,P3                 ; 1
        page0
        AND     A,TEMP2_0              ; 1
        CAJE    _RX_DATA,@F          ; 3
        JMP     @B                   ; 2
@@:
        page1
        MOV     A,RECEIVE_COUNT_1
        INCA
        MOV     RECEIVE_COUNT_1,A
        CAJE    #1  , @IS_IR_RX_1
        CAJE    #2  , @IS_IR_RX_2
        CAJE    #3  , @IS_IR_RX_3
        CAJE    #4  , @IS_IR_RX_4
        CAJE    #5  , @IS_IR_RX_5
        CAJE    #6  , @IS_IR_RX_6
        CAJE    #7  , @IS_IR_RX_7
        CAJE    #8  , @IS_IR_RX_8

@IS_IR_RX_1:
        @@@IR_RX_DATA   #1000B,RECEIVE_H
        JMP     @RECEIVE_IR_AGAIN

@IS_IR_RX_2:
        @@@IR_RX_DATA   #0100B,RECEIVE_H
        JMP     @RECEIVE_IR_AGAIN

@IS_IR_RX_3:
        @@@IR_RX_DATA   #0010B,RECEIVE_H
        JMP     @RECEIVE_IR_AGAIN

@IS_IR_RX_4:
        @@@IR_RX_DATA   #0001B,RECEIVE_H
        JMP     @RECEIVE_IR_AGAIN

@IS_IR_RX_5:
        @@@IR_RX_DATA   #1000B,RECEIVE_L
        JMP     @RECEIVE_IR_AGAIN

@IS_IR_RX_6:
        @@@IR_RX_DATA   #0100B,RECEIVE_L
        JMP     @RECEIVE_IR_AGAIN
@IS_IR_RX_7:
        @@@IR_RX_DATA   #0010B,RECEIVE_L

@Ready_RECEIVE_IR_AGAIN:
        @@@RECEIVE_700us
        page0
        AND     A,TEMP2_0
        CAJE    #0,@RECEIVE_IR_AGAIN

;;;;;;;  RECEIVE IR DATA ERROR  ;;;;;;;;
        JMP     @@RECEIVE_HFLF

@IS_IR_RX_8:
;;;;;;  @@@IR_RX_DATA   #0001B,RECEIVE_L
        @@@RECEIVE_1ms
        page0
        AND     A,TEMP2_0
        CAJE    #0,@F
        page4
        MOV     A,#0001B
        OR      A,RECEIVE_L
        MOV     RECEIVE_L,A
@@:
;;;;############################################
;;;;############################################
;;;;    Determine receive IR code
;;;;############################################
;;;;############################################
        PAGE4
        MOV     A,RECEIVE_H
        CAJE    #00H , @@RECEIVE_H0
        CAJE    #01H , @@RECEIVE_H1
        CAJE    #02H , @@RECEIVE_H2
        CAJE    #03H , @@RECEIVE_H3
        CAJE    #04H , @@RECEIVE_H4
        CAJE    #05H , @@RECEIVE_H5
        CAJE    #06H , @@RECEIVE_H6
        CAJE    #07H , @@RECEIVE_H7
        CAJE    #08H , @@RECEIVE_H8
        CAJE    #09H , @@RECEIVE_H9
        CAJE    #0AH , @@RECEIVE_HA
        CAJE    #0BH , @@RECEIVE_HB
        CAJE    #0CH , @@RECEIVE_HC
        CAJE    #0DH , @@RECEIVE_HD
        CAJE    #0EH , @@RECEIVE_HE
        JMP            @@RECEIVE_HF

        @@@DETERMINE_IR_RX_DATA  0
        @@@DETERMINE_IR_RX_DATA  1
        @@@DETERMINE_IR_RX_DATA  2
        @@@DETERMINE_IR_RX_DATA  3
        @@@DETERMINE_IR_RX_DATA  4
        @@@DETERMINE_IR_RX_DATA  5
        @@@DETERMINE_IR_RX_DATA  6
        @@@DETERMINE_IR_RX_DATA  7
        @@@DETERMINE_IR_RX_DATA  8
        @@@DETERMINE_IR_RX_DATA  9
        @@@DETERMINE_IR_RX_DATA  A
        @@@DETERMINE_IR_RX_DATA  B
        @@@DETERMINE_IR_RX_DATA  C
        @@@DETERMINE_IR_RX_DATA  D
        @@@DETERMINE_IR_RX_DATA  E
;;;;;;  @@@DETERMINE_IR_RX_DATA  F
@@RECEIVE_HF:
	page4
        MOV     A,RECEIVE_L
        CAJE    #00H , @@RECEIVE_HFL0
        CAJE    #01H , @@RECEIVE_HFL1
        CAJE    #02H , @@RECEIVE_HFL2
        CAJE    #03H , @@RECEIVE_HFL3
        CAJE    #04H , @@RECEIVE_HFL4
        CAJE    #05H , @@RECEIVE_HFL5
        CAJE    #06H , @@RECEIVE_HFL6
        CAJE    #07H , @@RECEIVE_HFL7
        CAJE    #08H , @@RECEIVE_HFL8
        CAJE    #09H , @@RECEIVE_HFL9
        CAJE    #0AH , @@RECEIVE_HFLA
        CAJE    #0BH , @@RECEIVE_HFLB
        CAJE    #0CH , @@RECEIVE_HFLC
        CAJE    #0DH , @@RECEIVE_HFLD
        CAJE    #0EH , @@RECEIVE_HFLE
        CAJE    #0FH , @@RECEIVE_HFLF
        JMP     @IR_RECEIVE_OK

endif             


ifdef  @@_EZ_IO_@@
Check_EZIO_Delay:
	page4 
	mov	a	EZIO_flag
	caje	#0000b	@@Check_EZIO_Delay_bk
	mov	a	EZIO_timerH

	caje	#0000b	@f
	jmp	@@delayIO
@@:
	mov	a	EZIO_timerL	
	caje	#0000b	@@EZIO_Item
	
@@delayIO:	
	
        mov     a       EZIO_timerL
        inca
        mov     EZIO_timerL a
        
        caje    #0000b  @@IO01_sec
        jmp	@@Check_EZIO_Delay_bk
@@IO01_sec:
        mov     a       EZIO_timerH
        inca
        mov     EZIO_timerH a           
        caje    #0000b  @@EZIO_Item
        jmp	@@Check_EZIO_Delay_bk
	
@@EZIO_end:

	DisableEZIO_@@
        page4
        mov  a       #0010b
        or   a       EventFlag			  ;bit1=1 of EventFlag no read event mark
        mov  EventFlag a 
	jmp	@@Check_EZIO_Delay_bk

@@EZIO_Item:
	rcode
	page4
	mov	temp6	a
	page0
	mov	a	fra1
	mov	temp2	a
	mov	a	#0011b
	and	a	temp2
	caje	#0000b 	@@Load_EZIO_Timer
	caje	#0001b	@@Load_IO_data
	caje	#0010b	@@load_PWMIO
	
	mov	a	fra2
	caje	#0000b	@@Load_EZIO_mark1		;for e0~e15
;	caje	#0001b	@@Load_EZIO_mark2		;for e16~e31
;	caje	#0010b	@@Load_EZIO_mark3		;for e32~e47
;	caje	#0011b	@@Load_EZIO_mark4		;for e48~e63
	caje	#0100b	@@Extend_Head_EZIO_Timer
	caje	#1000b	@@Extend_Tail	
	caje	#1111b	@@EZIO_end
	jmp	@@EZIO_Item
@@EZIO_BK:	
	page4
	mov	a	EZIO_flag
	caje	#0011b 	@f
	caje	#0111b	@@no_wave_ezio
	caje	#1011b	@@wave_ezio_event
	caje	#1111b	@@no_wave_ezio_event
	jmp	@@Check_EZIO_Delay_bk
@@:
	page4	
	mov	EZIO_flag	#0001b		;clear EZIO flag
	page0
	mov	a	#0010b
	and	a	EZIO_FG
	caje	#0000b	@@wave_ezio_ret2	
	page4	
	ret1
@@wave_ezio_ret2:
	page4
	ret2	
@@no_wave_ezio:
	page4
	mov	EZIO_flag	#0101b		;clear EZIO flag
;	ret1						;return to main loop
	page0
	mov	a	#0010b
	and	a	EZIO_FG
	caje	#0000b	@@no_wave_ezio_ret2
	page4
	ret1
@@no_wave_ezio_ret2:
	page4
	ret2
	
@@wave_ezio_event:
	page4
	mov	EZIO_flag	#1001b		;clear EZIO flag
;	ret1						;return to main loop
	page0
	mov	a	#0010b
	and	a	EZIO_FG
	caje	#0000b	@@wave_ezio_event_ret2
	page4
	ret1
@@wave_ezio_event_ret2:
	page4
	ret2
@@no_wave_ezio_event:
	page4
	mov	EZIO_flag	#1101b		;clear EZIO flag
;	ret1						;return to main loop
	page0
	mov	a	#0010b
	and	a	EZIO_FG
	caje	#0000b	@@no_wave_ezio_event_ret2
	page4
	ret1
@@no_wave_ezio_event_ret2:
	page4
	ret2
	
@@Load_EZIO_Timer:
	page4
	mov	a	temp6
	page4
	mov	EZIO_timerL	a
	mov	a	fra2
	mov	EZIO_timerH	a
	
	jmp	@@EZIO_BK

@@Extend_Head_EZIO_Timer:
	page4					;load EZIO timer count value
	mov	a	temp6
	page4
	mov	EZIO_timerL	a			; Extend TimerL
	rcode					; Next word is TimerH
	mov	EZIO_timerH	a			; Load TimerH into EZIO_timerH
	rstcf
	jmp	@@SCANKEY1

@@Extend_tail:
	page4
	mov	EZIO_flag	#0111b
	jmp	@@EZIO_Item

@@Load_EZIO_mark1:				;Event mark flag setting & e0~e15 information setting
	page4
	mov	EZ_MarkH	#0000b		; because bit0&1 will "and" with Fra3 bit0&1, so set "high" 
	jmp	@@Load_EZIO_mark	
;@@Load_EZIO_mark2:				;Event mark flag setting & e16~e31 information setting
;	page5
;	mov	EZ_MarkH	#0001b		; because bit0&1 will "and" with Fra3 bit0&1, so set "high" 
;	jmp	@@Load_EZIO_mark	
;@@Load_EZIO_mark3:				;Event mark flag setting & e32~e47 information setting
;	page5
;	mov	EZ_MarkH	#0010b		; because bit0&1 will "and" with Fra3 bit0&1, so set "high" 
;	jmp	@@Load_EZIO_mark	
;@@Load_EZIO_mark4:				;Event mark flag setting & e48~e63 information setting
;	page5
;	mov	EZ_MarkH	#0011b		; because bit0&1 will "and" with Fra3 bit0&1, so set "high" 
;	jmp	@@Load_EZIO_mark
	
@@Load_EZIO_mark:
	page4

	mov	a	temp6
	mov	EZ_Mark	a		
	mov	a	#1000b
	or	a	EZIO_flag
	mov	EZIO_flag	a
	jmp	@@EZIO_Item		

@@load_PWMIO:
	page4
	mov	a	temp6
	caje	#0011b	@@EZ_P3_PWM
		
@@not_P3_P6:
	page0
	mov	a	fra2
	mov	temp2	#1000b
	and	a	temp2
	caje	#0000b	read_1T
	rcode
	rcode
read_1T:
	rcode
	jmp	@@EZIO_Item

@@EZ_P3_PWM:
	page0
	mov	a	fra2
	caje	#0000b  @@set_P30_PWM
	caje	#0001b  @@set_P31_PWM
	caje	#0010b	@@set_P32_PWM
	caje	#0011b  @@set_P33_PWM
;	caje	#1000b  @@set_P30_auto_PWM
;	caje	#1001b  @@set_P31_auto_PWM
;	caje	#1010b	@@set_P32_auto_PWM
;	caje	#1011b  @@set_P33_auto_PWM
	jmp	@@not_P3_P6

@@set_P30_PWM:	
	
		
	rcode
	mov	temp2	a
	mov	a	fra2
	mov	PWM1H	a
	mov	a	temp2
	mov	PWM1L	a
	PWMIO_EN1
	jmp	@@EZIO_Item

@@set_P31_PWM:	
	
	rcode
	mov	temp2	a
		
	mov	a	fra2
	mov	PWM2H	a
	mov	a	temp2
	mov	PWM2L	a
	PWMIO_EN2
	jmp	@@EZIO_Item	

@@set_P32_PWM:	
	
	rcode
	mov	temp2	a	
	mov	a	fra2
	mov	PWM3H	a
	mov	a	temp2
	mov	PWM3L	a
	PWMIO_EN3
	jmp	@@EZIO_Item	
	
@@set_P33_PWM:	
	
	rcode
	mov	temp2	a
		
	mov	a	fra2
	mov	PWM4H	a
	mov	a	temp2
	mov	PWM4L	a
	PWMIO_EN4
	jmp	@@EZIO_Item	

@@set_P30_auto_PWM:
	rcode
@@set_P31_auto_PWM:		

@@set_P32_auto_PWM:

@@set_P33_auto_PWM:
	jmp	@@EZIO_Item
	
	
@@Load_IO_data:
	page4
	mov	a	temp6
	caje	#0001b	@@EZ_P1_0
	caje	#0010b	@@EZ_P2_0
	caje	#0011b	@@EZ_P3_0
;	caje	#0110b	@@EZ_P6_0
	
	caje	#1001b	@@EZ_P1_1
	caje	#1010b	@@EZ_P2_1
	caje	#1011b	@@EZ_P3_1
;	caje	#1110b	@@EZ_P6_1
	jmp	@@EZIO_Item

		
;;----------------------------------------------
@@EZ_P1_0:
	mov	a	fra2
	page2
	caje	#0000b  @@SetP10_0
	caje	#0001b  @@SetP11_0
	caje	#0010b  @@SetP12_0
	caje	#0011b  @@SetP13_0
	jmp	@@EZIO_Item

@@EZ_P1_1:
	mov	a	fra2
	page2
	caje	#0000b	@@SetP10_1
	caje	#0001b	@@SetP11_1
	caje	#0010b	@@SetP12_1
	caje	#0011b	@@SetP13_1
	jmp	@@EZIO_Item	
	
@@SetP10_0:
	mov	a	#1110b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#1110b
	and	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item		
@@SetP10_1:
	mov	a	#1110b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#0001b
	or	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item	
	
@@SetP11_0:
	mov	a	#1101b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#1101b
	and	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item		
@@SetP11_1:
	mov	a	#1101b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#0010b
	or	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item	

@@SetP12_0:
	mov	a	#1011b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#1011b
	and	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item		
@@SetP12_1:
	mov	a	#1011b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#0100b
	or	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item			
	
@@SetP13_0:
	mov	a	#0111b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#0111b
	and	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item		
@@SetP13_1:
	mov	a	#0111b
	and	a	P1_go2
	mov	P1_go2	a
	mov	a	#1000b
	or	a	P1_go1
	mov	P1_go1	a
	jmp	@@EZIO_Item	
;;========================================================
@@EZ_P2_0:
	mov	a	fra2
	page2
	caje	#0000b  @@SetP20_0
	caje	#0001b  @@SetP21_0
	caje	#0010b  @@SetP22_0
	caje	#0011b  @@SetP23_0
	jmp	@@EZIO_Item
	
@@EZ_P2_1:
	mov	a	fra2
	page2
	caje	#0000b	@@SetP20_1
	caje	#0001b	@@SetP21_1
	caje	#0010b	@@SetP22_1
	caje	#0011b	@@SetP23_1
	jmp	@@EZIO_Item	
	
@@SetP20_0:
	mov	a	#1110b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#1110b
	and	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item		
@@SetP20_1:
	mov	a	#1110b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#0001b
	or	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item	
	
@@SetP21_0:
	mov	a	#1101b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#1101b
	and	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item		
@@SetP21_1:
	mov	a	#1101b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#0010b
	or	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item	

@@SetP22_0:
	mov	a	#1011b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#1011b
	and	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item		
@@SetP22_1:
	mov	a	#1011b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#0100b
	or	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item			
	
@@SetP23_0:
	mov	a	#0111b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#0111b
	and	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item		
@@SetP23_1:
	mov	a	#0111b
	and	a	P2_go2
	mov	P2_go2	a
	mov	a	#1000b
	or	a	P2_go1
	mov	P2_go1	a
	jmp	@@EZIO_Item	
;;----------------------------------------------------
@@EZ_P3_0:
	mov	a	fra2
	page2
	caje	#0000b  @@SetP30_0
	caje	#0001b  @@SetP31_0
	caje	#0010b  @@SetP32_0
	caje	#0011b  @@SetP33_0
	jmp	@@EZIO_Item
	
@@EZ_P3_1:
	mov	a	fra2
	page2
	caje	#0000b	@@SetP30_1
	caje	#0001b	@@SetP31_1
	caje	#0010b	@@SetP32_1
	caje	#0011b	@@SetP33_1
	jmp	@@EZIO_Item	
@@SetP30_0:
	
	
	mov	a	#1110b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#1110b
	and	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF1
	jmp	@@EZIO_Item		
@@SetP30_1:
	
	mov	a	#1110b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#0001b
	or	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF1
	jmp	@@EZIO_Item	
	
@@SetP31_0:
	
	mov	a	#1101b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#1101b
	and	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF2
	jmp	@@EZIO_Item		
@@SetP31_1:
	
	mov	a	#1101b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#0010b
	or	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF2
	jmp	@@EZIO_Item	

@@SetP32_0:
	
	mov	a	#1011b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#1011b
	and	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF3
	jmp	@@EZIO_Item		
@@SetP32_1:
	
	mov	a	#1011b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#0100b
	or	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF3
	jmp	@@EZIO_Item			
	
@@SetP33_0:
	
	mov	a	#0111b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#0111b
	and	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF4
	jmp	@@EZIO_Item		
@@SetP33_1:
	
	mov	a	#0111b
	and	a	P3_go2
	mov	P3_go2	a
	mov	a	#1000b
	or	a	P3_go1
	mov	P3_go1	a
	PWMIO_OFF4
	jmp	@@EZIO_Item		

;;+++++++++++++++++++++++++++++++++++++++++++++	


endif	
	


ifdef	PWMEN12
ChecK_PWMIO_P3:
	page4
	mov	a	PWMIOEN1
	caje	#0000b	@@ChecK_PWMIO_P3_bk
	mov	a	#0001b
	and	a	PWMIOEN1
	caje	#0001b	@@adj_P30_PWM
@@check_P31_PWM:	
	page4
	mov	a	#0010b
	and	a	PWMIOEN1
	caje	#0010b	@@adj_P31_PWM
@@check_P32_PWM:	
	page4
	mov	a	#0100b
	and	a	PWMIOEN1
	caje	#0100b	@@adj_P32_PWM
@@check_P33_PWM:
	page4
	mov	a	#1000b
	and	a	PWMIOEN1
	caje	#1000b	@@adj_P33_PWM
	jmp	@@ChecK_PWMIO_P3_bk


@@adj_P30_PWM:
	page6
	mov	a	P30_step_TL
	inca	
	mov	P30_step_TL	a
	caje	#0000b	@@adj_P30_PWM_H
	jmp	@@check_P31_PWM			
@@adj_P30_PWM_H:
        mov	a	P30_step_TH
	inca	
	mov	P30_step_TH	a
	caje	#0000b	@@add_P30_PWM_duty
	jmp	@@check_P31_PWM
;-----------------------------------------
@@adj_P31_PWM:
	page6
	mov	a	P31_step_TL
	inca	
	mov	P31_step_TL	a
	caje	#0000b	@@adj_P31_PWM_H
	page4
	jmp	@@check_P32_PWM			
@@adj_P31_PWM_H:
        mov	a	P31_step_TH
	inca	
	mov	P31_step_TH	a
	caje	#0000b	@@add_P31_PWM_duty
	page5
	jmp	@@check_P32_PWM
;----------------------------------------
@@adj_P32_PWM:
	page6
	mov	a	P32_step_TL
	inca	
	mov	P32_step_TL	a
	caje	#0000b	@@adj_P32_PWM_H
	
	jmp	@@check_P33_PWM			
@@adj_P32_PWM_H:
        mov	a	P32_step_TH
	inca	
	mov	P32_step_TH	a
	caje	#0000b	@@add_P32_PWM_duty
	
	jmp	@@check_P33_PWM	
;----------------------------------------------
@@adj_P33_PWM:
	page6
	mov	a	P33_step_TL
	inca	
	mov	P33_step_TL	a
	caje	#0000b	@@adj_P33_PWM_H
	jmp	@@ChecK_PWMIO_P3_bk		
@@adj_P33_PWM_H:
        mov	a	P33_step_TH
	inca	
	mov	P33_step_TH	a
	caje	#0000b	@@add_P33_PWM_duty
	jmp	@@ChecK_PWMIO_P3_bk
;----------------------------------------------	
@@add_P30_PWM_duty:
	mov	a	P30_duty_L
	inca	
	mov	P30_duty_L	a
	caje	#0000b	@@add_P30_duty_H
@@load_PWM1L:	
	mov	a	P30_duty_L
	mov	PWM1L	a
	page7
	mov	a	P30_timer_tempH
	page6
	mov	P30_step_TH	a
	page5
	jmp	@@check_P31_PWM	
@@add_P30_duty_H:
	mov	a	P30_duty_H
	inca	
	mov	P30_duty_H	a
	mov	PWM1H	a
	jmp	@@load_PWM1L	
;;-----------------------------------------------
@@add_P31_PWM_duty:
	mov	a	P31_duty_L
	inca	
	mov	P31_duty_L	a
	caje	#0000b	@@add_P31_duty_H
@@load_PWM2L:	
	mov	PWM2L	a
	page5
	jmp	@@check_P32_PWM	
@@add_P31_duty_H:
	mov	a	P31_duty_H
	inca	
	mov	P31_duty_H	a
	mov	PWM2H	a
	jmp	@@load_PWM2L		
;--------------------------------------------------
@@add_P32_PWM_duty:
	mov	a	P32_duty_L
	inca	
	mov	P32_duty_L	a
	caje	#0000b	@@add_P32_duty_H
@@load_PWM3L:	
	mov	PWM3L	a
	page5
	jmp	@@check_P33_PWM	
@@add_P32_duty_H:
	mov	a	P32_duty_H
	inca	
	mov	P32_duty_H	a
	mov	PWM3H	a
	jmp	@@load_PWM3L			
;----------------------------------------------------	
@@add_P33_PWM_duty:
	mov	a	P33_duty_L
	inca	
	mov	P33_duty_L	a
	caje	#0000b	@@add_P33_duty_H
@@load_PWM4L:	
	mov	PWM4L	a
	jmp	@@ChecK_PWMIO_P3_bk
@@add_P33_duty_H:
	mov	a	P33_duty_H
	inca	
	mov	P33_duty_H	a
	mov	PWM4H	a
	jmp	@@load_PWM4L	
endif		

@@_4MS	EQU	@@SCANKEY1
LOCKED_OUT1	EQU	#0000B
LOCKED_OUT2	EQU	#0000B
READY1	EQU	#0000B
READY2	EQU	#0001B
RUNNING1	EQU	#0000B
RUNNING2	EQU	#0010B
@@TR1R:
	PAGE1
	MOV	A	TrigState1
	CAJE	#0000B	@@TR1R_0
	JMP	@@SCANKEY1
@@TR1R_0:
	MOV	A	TrigState2
	CAJE	#0001B	@@_START_TIMER
	CAJE	#0010B	@@_STOP_TIMER
	JMP	@@SCANKEY1
@@TR1F	EQU	@@SCANKEY1
@@TR2R	EQU	@@SCANKEY1
@@TR2F	EQU	@@SCANKEY1
@@TR3R	EQU	@@SCANKEY1
@@TR3F	EQU	@@SCANKEY1
@@TR4R	EQU	@@SCANKEY1
@@TR4F	EQU	@@SCANKEY1
@@TR5R	EQU	@@SCANKEY1
@@TR5F	EQU	@@SCANKEY1
@@TR6R	EQU	@@SCANKEY1
@@TR6F	EQU	@@SCANKEY1
@@TR7R	EQU	@@SCANKEY1
@@TR7F	EQU	@@SCANKEY1
@@TR8R	EQU	@@SCANKEY1
@@TR8F	EQU	@@SCANKEY1
@@TR9R	EQU	@@SCANKEY1
@@TR9F	EQU	@@SCANKEY1
@@TR10R	EQU	@@SCANKEY1
@@TR10F	EQU	@@SCANKEY1
@@TR11R	EQU	@@SCANKEY1
@@TR11F	EQU	@@SCANKEY1
@@TR12R	EQU	@@SCANKEY1
@@TR12F	EQU	@@SCANKEY1
@@TR13R	EQU	@@SCANKEY1
@@TR13F	EQU	@@SCANKEY1
@@TR14R	EQU	@@SCANKEY1
@@TR14F	EQU	@@SCANKEY1
@@TR15R	EQU	@@SCANKEY1
@@TR15F	EQU	@@SCANKEY1
@@TR16R	EQU	@@SCANKEY1
@@TR16F	EQU	@@SCANKEY1
@@_INIT:
	PAGE1	
	MOV	TrigState1	LOCKED_OUT1
	MOV	TrigState2	LOCKED_OUT2
	FREQ	#0010B	#1110B
	Xi_data	X0,0
	Xi_data	X1,0
	PAGE1	
	MOV	TrigState1	READY1
	MOV	TrigState2	READY2
	JMP	@@SCANKEY1
@@_START_TIMER:
	PAGE1	
	MOV	TrigState1	RUNNING1
	MOV	TrigState2	RUNNING2
	Xi_data	X0,0
	Pn_Data_LABEL	P2,#0000B,#0001B,@@_SET_TIME1
	JMP	@@_SET_TIME2
@@_SET_TIME1:
	Xi_data	X1,10
	JMP	@@_TIMER_LOOP
@@_SET_TIME2:
	Xi_data	X1,30
	JMP	@@_TIMER_LOOP
@@_TIMER_LOOP:
	VoiceName	<TICK_TOCK_12K.WAV>
	Xi_Xj+data	X0,X0,1
	Xi?Xj_Label	X0,X1,@@_TIMEOUT
	JMP	@@_TIMER_LOOP
@@_TIMEOUT:
	Pn_Data_LABEL	P2,#0000B,#0010B,@@_SOUND1
	JMP	@@_SOUND2
@@_SOUND1:
	VoiceName	<GAME_SHOW_BUZZER_12K.WAV>
	PAGE1	
	MOV	TrigState1	READY1
	MOV	TrigState2	READY2
	JMP	@@SCANKEY1
@@_SOUND2:
	VoiceName	<RPG_AND_EXPLOSION_12K.WAV>
	PAGE1	
	MOV	TrigState1	READY1
	MOV	TrigState2	READY2
	JMP	@@SCANKEY1
@@_STOP_TIMER:
	STOP_V
	PAGE1	
	MOV	TrigState1	READY1
	MOV	TrigState2	READY2
	JMP	@@SCANKEY1
@@CHKBGROUND:
	JMP	@@CHKBGROUND_BACK
@@e1	EQU	@@SCANKEY1
@@e2	EQU	@@SCANKEY1
@@e3	EQU	@@SCANKEY1
@@e4	EQU	@@SCANKEY1
@@e5	EQU	@@SCANKEY1
@@e6	EQU	@@SCANKEY1
@@e7	EQU	@@SCANKEY1
@@e8	EQU	@@SCANKEY1
@@e9	EQU	@@SCANKEY1
@@e10	EQU	@@SCANKEY1
@@e11	EQU	@@SCANKEY1
@@e12	EQU	@@SCANKEY1
@@e13	EQU	@@SCANKEY1
@@e14	EQU	@@SCANKEY1
@@e15	EQU	@@SCANKEY1
